#include "mcc_generated_files/mcc.h"
#include "mcc_generated_files/examples/i2c1_master_example.h"

#define TIME_OFF -1         //^C}[gpȂꍇ
#define TIME_UP 0           //^CAbv
#define TIME_DHT20_MAX 500 //vEFCg
#define TIME_DHT20_WAIT 10 //vEFCg
#define TIME_OUT_MAX 1100 //ʐM^CAEg

#define POLYNOMIAL 0x31
#define SLAVE_ADRS 0x38

#define SLAVE_ADRS_LCD 0x3E//0x3E 0x7C
#define LINE1_ADRS 0x40
#define LINE2_TOP (0x40 +0x80)
#define FUNC1_SET 0x38
#define FUNC2_SET 0x39
#define INT_OSC 0x14
#define CONST_SET 0x77 //0x73
#define PWR_ICON_SET 0x54 //0x56
#define FOLLOWER_SET 0x6C
#define CLR_DISP 0x01
#define DISP_ONOFF_SET 0x0C

typedef enum{
    DHT20_INIT = 0,
    DHT20_MEASURE,
    DHT20_WAIT,
    DHT20_CHK,  
    DHT20_MAX  
}DHT20_MODE;

uint8_t disptbl[2][16] ={"humi:   50.00 % ","temp:   20.00 C "};
uint8_t trig[] = { 0xAC, 0x33, 0x00};
int16_t timDht20start;
int16_t  timDht20Out = TIME_OFF;
DHT20_MODE mode = DHT20_INIT;
uint8_t readData[7];
uint8_t dht20status;

void mainApp(void);
void mainTimer(void);
uint8_t Crc8Calc(uint8_t *data, uint8_t sz );
void LcdInit(void);
void DispSet(void);
void DspLine2Top(void);
void DspClear(void);
void Datachk(void);

/* Main application */
void main(void)
{
    SYSTEM_Initialize();
    TMR0_SetInterruptHandler(mainTimer);
    INTERRUPT_GlobalInterruptEnable();
    INTERRUPT_PeripheralInterruptEnable();
    
    LcdInit();

    while (1)
    {
        mainApp();
    }
}
/* ^C}Ǘ֐ */
void mainTimer(void){
    
    if( timDht20start > TIME_UP ){
        --timDht20start;
    }
    
    if( timDht20Out > TIME_UP ){
        --timDht20Out;
    }
}
/* C֐ */
void mainApp(void){
    
  switch(mode){
      case DHT20_INIT:  
        if( timDht20start == TIME_UP ){
            timDht20start = TIME_DHT20_WAIT;
            I2C1_Read1ByteRegister(SLAVE_ADRS, dht20status );
            if( dht20status != 0x18 ){
              //dOFFĂȑǑvԂcĂ0x18ȊOɂȂ邽ߕsv?
                mode = DHT20_MEASURE;
            }
            else{
                mode = DHT20_MEASURE;
            }
        }
         break;
    case DHT20_MEASURE:
        if( timDht20start == TIME_UP ){
            timDht20start = TIME_DHT20_WAIT;
            timDht20Out = TIME_OUT_MAX;
            I2C1_WriteNBytes(SLAVE_ADRS, &trig[0], sizeof(trig));
            mode = DHT20_WAIT;
        }
        break;
    case DHT20_WAIT:
        if( timDht20start == TIME_UP ){
            timDht20start = TIME_DHT20_WAIT;
            I2C1_ReadNBytes(SLAVE_ADRS, &readData[0], sizeof(readData) );
            if( (readData[0] & 0x80 ) == 0){
                mode = DHT20_CHK;
            }
            else{
                mode = DHT20_MEASURE;
            }
        }
        break;
    case DHT20_CHK:
        if( timDht20start == TIME_UP ){
            timDht20start = TIME_DHT20_MAX;
            timDht20Out = TIME_OFF;
            Datachk();
            mode = DHT20_MEASURE;
        }
        break;
    case DHT20_MAX:
        //ɎsꍇȂǂ̏ǉȂ炱
        break;
  }

    if( timDht20Out == TIME_UP ){
        timDht20Out = TIME_OFF;
        mode = DHT20_MEASURE;
        timDht20start = DHT20_MEASURE;
    }    
}
/* CRC8vZ֐ */    
uint8_t Crc8Calc(uint8_t *data, uint8_t sz ){
    int crc = 0xFF;
    uint8_t i,j;
    
    for( i = 0; i < sz; i++){
        crc ^= *data;
        
        for( j = 0; j < 8; j++ ){
            if( crc & 0x80 ){
               crc = ( crc << 1 ) ^ POLYNOMIAL;
            }
            else{
               crc = crc << 1;
            }
        }
        ++data;
    }
    
    return (uint8_t)crc;
}
/* CRC`FbNƎxƉxf[^ɊZ */
void Datachk(void){
    int64_t temp;
    int64_t humid;
    //float tempdata;
    //float humiddata;
    int64_t humiddata;
    int64_t tempdata;
    uint8_t crc;
    uint8_t i;
    bool nega = false;
    uint8_t disp10000;
    uint8_t disp1000;
    uint8_t disp100;
    uint8_t disp10;
    uint8_t disp1;
    uint8_t cnt;

    crc = Crc8Calc( &readData[0],6);

    if( crc == readData[6]){
        humid = ( (int64_t)readData[1] << 12 )
              + ( (int64_t)readData[2] << 4 )
              + ( (int64_t)readData[3] >> 4 ) ;

        temp = ( ((int64_t)readData[3] & 0x0F) << 16 )
              + ( (int64_t)readData[4] << 8 )
              + ( (int64_t)readData[5] );
    
        //humiddata = ((float)humid / (1 << 20)) * 100;
        humiddata = (humid*10000 >> 20);
        //tempdata = ((float)temp / (1 << 20))*200 - 50;
        tempdata = (temp*20000 >> 20) - 5000;
         //sprintf(disp1, "Humid:  %d.%d %%", humi_i, humi_p);
    
        disp10000 = humiddata / 10000;
        disp1000 = ( humiddata % 10000) / 1000; 
        disp100 = (( humiddata % 10000) % 1000 ) / 100; 
        disp10 = ( humiddata % 100 ) / 10;
        disp1 = ( humiddata % 100 ) % 10;
    
        if( disp10000 == 0){
            disptbl[0][7] = ' ';
        }
        else{
            disptbl[0][7] = (uint8_t)disp10000 + 0x30;
        }
    
        disptbl[0][8] = (uint8_t)disp1000 + 0x30;    
        disptbl[0][9] = (uint8_t)disp100 + 0x30;
        disptbl[0][10] = '.';
        disptbl[0][11] = (uint8_t)disp10 + 0x30;
        disptbl[0][12] = (uint8_t)disp1 + 0x30;
    
        DspClear();
    
        for( i = 0; i < sizeof(disptbl[0]); i++ ){
            I2C1_Write1ByteRegister(SLAVE_ADRS_LCD,LINE1_ADRS,disptbl[0][i]);
        }     
    
        DspLine2Top();
         //sprintf(disp2, "Temp:  %d.%d%d C", temp_i, temp_p1,temp_p2);

        if( tempdata < 0 ){
            tempdata = abs(tempdata);
            nega = true;
        }
 
        disp10000 = tempdata / 10000;
        disp1000 = ( tempdata % 10000) / 1000; 
        disp100 = (( tempdata % 10000) % 1000 ) / 100; 
        disp10 = ( tempdata % 100 ) / 10;
        disp1 = ( tempdata % 100 ) % 10;
    
        if( disp10000 == 0){
            if( disp1000 == 0 ){
                cnt = 8;
            }
            else{
                cnt = 7;
            }

            if( nega == true){
                disptbl[1][cnt++] = '-';
            }
            else{
                disptbl[1][cnt++] = ' ';
            }
        }
        else{
            cnt = 7;
            disptbl[1][cnt++] = (uint8_t)disp10000 + 0x30;
        }
    
        if( disp1000 != 0 ){
            disptbl[1][cnt++] = (uint8_t)disp1000 + 0x30;
        }
        
        disptbl[1][cnt++] = (uint8_t)disp100 + 0x30;
        disptbl[1][cnt++] = '.';
        disptbl[1][cnt++] = (uint8_t)disp10 + 0x30;
        disptbl[1][cnt++] = (uint8_t)disp1 + 0x30;

        for( i = 0; i < sizeof(disptbl[1]); i++ ){
            I2C1_Write1ByteRegister(SLAVE_ADRS_LCD,LINE1_ADRS,disptbl[1][i]);
        } 
    }
}
/* LCD̏̊֐ */
void LcdInit(void){
    
    __delay_ms(100); //LCDNbNȂǈ莞Ԃ̃EFCg
  
    I2C1_Write1ByteRegister(SLAVE_ADRS_LCD, 0x00, FUNC1_SET );
    __delay_us(40);
    I2C1_Write1ByteRegister(SLAVE_ADRS_LCD, 0x00, FUNC2_SET );
    __delay_us(40);
    I2C1_Write1ByteRegister(SLAVE_ADRS_LCD, 0x00, INT_OSC );
    __delay_us(40);    
    I2C1_Write1ByteRegister(SLAVE_ADRS_LCD, 0x00, CONST_SET );
    __delay_us(40);    
    I2C1_Write1ByteRegister(SLAVE_ADRS_LCD, 0x00, PWR_ICON_SET );
    __delay_us(40);
    I2C1_Write1ByteRegister(SLAVE_ADRS_LCD, 0x00, PWR_ICON_SET );
    __delay_us(40);    
    I2C1_Write1ByteRegister(SLAVE_ADRS_LCD, 0x00, FOLLOWER_SET );
    __delay_ms(250);
    I2C1_Write1ByteRegister(SLAVE_ADRS_LCD, 0x00, FUNC1_SET );
    __delay_us(40);
    
    DspClear();
    
    I2C1_Write1ByteRegister(SLAVE_ADRS_LCD, 0x00, DISP_ONOFF_SET );
    __delay_us(40);
    
}
/* LCD̕\2iڂɃZbg */
void DspLine2Top(void){

    I2C1_Write1ByteRegister(SLAVE_ADRS_LCD, 0x00, LINE2_TOP );
    __delay_us(40);    
}
/* LCD̕\NA */
void DspClear(void){
  
    I2C1_Write1ByteRegister(SLAVE_ADRS_LCD, 0x00, CLR_DISP );
    __delay_us(40);
}
/* End of File */